'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _libMaybe = require('./lib/Maybe');

exports.Endo = Endo;
exports.compose = compose;
exports.filtering = filtering;
exports.foldMapOf = foldMapOf;
exports.foldrOf = foldrOf;
exports.get = get;
exports.getter = getter;
exports.to = getter;
exports.lens = lens;
exports.lookup = lookup;
exports.over = over;
exports.set = set;
exports.sumOf = sumOf;
exports.traverseOf = traverseOf;

/* Types */

/*
 * Supporting interfaces
 */

// `Pure_` is "pure" for functors - will not be invoked unless further
// constrained to `Pure`

/*
 * Algebraic implementations
 */

var Const = (function () {
  function Const(value) {
    _classCallCheck(this, Const);

    this.value = value;
  }

  _createClass(Const, [{
    key: 'map',
    value: function map(f) {
      return new Const(this.value);
    }
  }, {
    key: 'contramap',
    value: function contramap(f) {
      return new Const(this.value);
    }
  }]);

  return Const;
})();

var ApplyConst = (function (_Const) {
  _inherits(ApplyConst, _Const);

  function ApplyConst() {
    _classCallCheck(this, ApplyConst);

    _get(Object.getPrototypeOf(ApplyConst.prototype), 'constructor', this).apply(this, arguments);
  }

  _createClass(ApplyConst, [{
    key: 'ap',
    value: function ap(x) {
      return new ApplyConst(this.value.concat(x.value));
    }
  }, {
    key: 'map',
    value: function map(f) {
      return new ApplyConst(this.value);
    }
  }, {
    key: 'contramap',
    value: function contramap(f) {
      return new ApplyConst(this.value);
    }
  }]);

  return ApplyConst;
})(Const);

var Identity = (function () {
  function Identity(value) {
    _classCallCheck(this, Identity);

    this.value = value;
  }

  _createClass(Identity, [{
    key: 'map',
    value: function map(f) {
      return new Identity(f(this.value));
    }
  }, {
    key: 'ap',
    value: function ap(x) {
      var f = this.value;
      return new Identity(f(x.value));
    }
  }, {
    key: 'sequence',
    value: function sequence(pure) {
      return pure(this);
    }
  }]);

  return Identity;
})();

function constant(val) {
  return new Const(val);
}
function applyConstant(val) {
  return new ApplyConst(val);
}
function identity(val) {
  return new Identity(val);
}

// Ordinary function composition - also works to compose lenses
function compose(f, g) {
  return function (x) {
    return f(g(x));
  };
}

/* lenses */

/*
 * Creates a lens from a getter and setter function.
 */
function lens(getter, setter) {
  return function (f) {
    return function (pure, obj) {
      return f(pure, getter(obj)).map(function (val) {
        return setter(obj, val);
      });
    };
  };
}

/* getting */

/*
 * Turns an ordinary function into a getter
 */
function getter(getter) {
  return function (f) {
    return function (pure, obj) {
      return f(pure, getter(obj)).map(function (_) {
        return obj;
      });
    };
  };
}

/*
 * Given a getter (which is a specialized lens), and data structure, gets
 * a value out of the data structure.
 */
function get(getter, obj) {
  return getter(function (_, val) {
    return new Const(val);
  })(constant, obj).value;
}

/* setting */

function set(setter, val, obj) {
  return setter(function (_, __) {
    return new Identity(val);
  })(identity, obj).value;
}

function over(setter, f, obj) {
  return setter(function (_, a) {
    return new Identity(f(a));
  })(identity, obj).value;
}

/* traversing */

function traverseOf(pure, l, f, obj) {
  return l(f)(pure, obj);
}

function filtering(predicate) {
  return function (f) {
    return function (pure, obj) {
      return predicate(obj) ? f(pure, obj).map(id) : pure(obj);
    };
  };
  // TODO: `.map(id)` suppresses a (hopefully unimportant) type error
}

/* folding */

// `First` is one possible Monoid implementation for `Maybe`

var First = (function () {
  function First(value) {
    _classCallCheck(this, First);

    this.value = value;
  }

  _createClass(First, [{
    key: 'concat',
    value: function concat(other) {
      return this.value instanceof _libMaybe.Just ? this : other;
    }
  }, {
    key: 'empty',
    value: function empty() {
      return new First(_libMaybe.nothing);
    }
  }]);

  return First;
})();

function first(val) {
  return new First(val);
}

function foldMapOf(l, f, mempty, obj) {
  var wrapConst = function wrapConst(pure, val) {
    return applyConstant(f(val));
  };
  return l(wrapConst)(function (_) {
    return applyConstant(mempty);
  }, obj).value;
}

// `Endo` turns a function into a Monoid

var Endo = (function () {
  function Endo(f) {
    _classCallCheck(this, Endo);

    this.f = f;
  }

  _createClass(Endo, [{
    key: 'concat',
    value: function concat(other) {
      return new Endo(compose(this.f, other.f));
    }
  }, {
    key: 'empty',
    value: function empty() {
      return new Endo(id);
    }
  }]);

  return Endo;
})();

function endo(f) {
  return new Endo(f);
}

function foldrOf(l, f, init, obj) {
  var curried = function curried(val) {
    return function (accum) {
      return f(val, accum);
    };
  };
  return foldMapOf(l, compose(endo, curried), new Endo(id), obj).f(init);
}

function sumOf(l, obj) {
  return foldrOf(l, function (x, y) {
    return x + y;
  }, 0, obj);
}

/*
 * `lookup` is like `get`, except that the result might be `undefined`.
 *
 * `get` cannot be used with `Traversal` or `Fold` lenses.
 * In these cases, use `lookup` instead.
 *
 */
function lookup(l, obj) {
  function toMonoid(val) {
    return first((0, _libMaybe.just)(val));
  }
  return foldMapOf(l, toMonoid, first(_libMaybe.nothing), obj).value.value;
}

function id(val) {
  return val;
}