
// TODO: Can we remove hard dependency on immutable?

// import * as FS from './fantasy-land'
'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _fantasyLand = require('./fantasy-land');

var _immutable = require('immutable');

// export type Traversable<V> = FS.Traversable<V> | V[]
// FS.Traversable<V> | V[] | Map<any,V> | Set<any,V> | Iterable<any,V>

exports.sequence = sequence;
exports.traverse = traverse;

// var { ap } = FS

function sequence(pure, t) {
  if (typeof t.sequence !== 'undefined') {
    return t.sequence(pure);
  } else if (t instanceof Array) {
    return sequenceArray(pure, t);
  }
  // else if (t instanceof Map) {}
  // else if (t instanceof Set) {}
  // else if (t instanceof Iterable) {}
  else {
      throw new TypeError('No implementation of Traversable for ' + String(t));
    }
}

function traverse(pure, f, t) {
  return sequence(pure, t.map(f));
}

function sequenceArray(pure, t) {
  var append = pure(function (ys) {
    return function (x) {
      return ys.concat(x);
    };
  });
  return t.reduce(function (ys, x) {
    return (0, _fantasyLand.ap)((0, _fantasyLand.ap)(append, pure(ys)), x);
  }, pure([]));
}